﻿//configure app defaults
$(document).bind("mobileinit", function () {
    $.extend($.mobile, {
        defaultPageTransition: 'none'
    });

    setupAppDB();
});

function setupAppDB() {
    //create table if not exists
    var db = window.openDatabase("Database", "1.0", "CFG Favorites", 1024*1024);
    db.transaction(populateDB, errorCB);

    //load default settings
    $('#sliderDnlImages').val((localStorage.settingsShowImages == 'undefined' ? 'on' : 'off'));
}

function populateDB(tx) {
    //tx.executeSql('DROP TABLE IF EXISTS favorites');
    tx.executeSql('CREATE TABLE IF NOT EXISTS favorites (gameid, gametitle, thumbnail, platform, releasedate, price)');
    //tx.executeSql('INSERT INTO favorites (gameid, gametitle, thumbnail, platform, releasedate) VALUES (1, "Game 1", "test.jpg", "ps3", "01/06/2012")');
}

function errorCB(err) {
    navigator.notification.confirm(
        'Sorry, there seems to be a temporary problem. Please try again later.',
        null,
        'Error',
        'OK'
    );
}

function insertFavorite(dbGameid, dbGameTitle, dbThumbnail, dbPlatform, dbReleaseDate) {
    var db = window.openDatabase("Database", "1.0", "CFG Favorites", 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('DELETE FROM favorites WHERE gameid = ?', [dbGameid]);
        tx.executeSql('INSERT INTO favorites (gameid, gametitle, thumbnail, platform, releasedate) VALUES (?, ?, ?, ?, ?)', [dbGameid, dbGameTitle, dbThumbnail, dbPlatform, dbReleaseDate]);
        $('#btnFavorite').hide();
    });
}

function deleteFavorite(dbGameid) {
    var db = window.openDatabase("Database", "1.0", "CFG Favorites", 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('DELETE FROM favorites WHERE gameid = ?', [dbGameid]);
    });

    getFavorites();
}


function getFavorites() {
    var db = window.openDatabase("Database", "1.0", "CFG Favorites", 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('SELECT * FROM favorites ORDER BY gametitle', [], populateFavorites, errorCB);
    });
}

function showHideFavoriteBtn(gameid) {
    var db = window.openDatabase("Database", "1.0", "CFG Favorites", 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('SELECT * FROM favorites WHERE gameid = "' + gameid + '"', [], function (tx, results) {
            if (results.rows.length > 0) {
                $('#btnFavorite').hide();
            }
            else {
                $('#btnFavorite').show();
            }
        }
        , errorCB);
    });
}

function populateFavorites(tx, results) {
    $('#lvFavorites').html('');
    for (var i = 0; i < results.rows.length; i++) {
        var id = results.rows.item(i).gameid;
        var gametitle = results.rows.item(i).gametitle;
        var platform = results.rows.item(i).platform;
        var releasedate = results.rows.item(i).releasedate;
        var thumbnail = results.rows.item(i).thumbnail;
        if ((localStorage.settingsShowImages == 'off') || (thumbnail == "")) {
            thumbnail = 'images/imageunavailableThumb.jpg';
        }
        //$('#lvFavorites').append('<li><a data-role="button" id="' + results.rows.item(i).gameid + '"><img src="' + results.rows.item(i).thumbnail + '" /><h3>' + results.rows.item(i).gametitle + '</h3><p>' + results.rows.item(i).platform + '</p></a><a class="delfav" id="' + results.rows.item(i).gameid + '" data-icon="delete" data-role="button"></a></li>');
        $('#lvFavorites').append('<li><a data-role="button" id="' + id + '"><img src="' + thumbnail + '" /><h3>' + gametitle + '</h3><p>' + platform + '</p><span class="releasedate" style="display:none">' + releasedate + '</span><span class="platform" style="display:none">' + platform + '</span></a><a class="delfav" id="' + id + '" data-icon="delete" data-role="button"></a></li>');
    }
    $('#lvFavorites').listview('refresh');

    //attach click events to list items
    $('#lvFavorites li').on("tap", function () {
        localStorage.currentId = $('a', this).attr("id");
        localStorage.currentTitle = $('h3', this).html();
        localStorage.currentPlatform = $('.platform', this).html();
        localStorage.currentReleaseDate = $('.releasedate', this).html();
        localStorage.currentThumbnail = $('img', this).attr("src");
        GetGameDetails(localStorage.currentId);
    });

    //attach click events to list items
    $('.delfav').on("tap", function () {
        $.mobile.showPageLoadingMsg();
        var gameid = $(this).attr("id");
        deleteFavorite(gameid);
        $.mobile.hidePageLoadingMsg();
        return false;
        //localStorage.currentId = $('a', this).attr("id");
        //GetGameDetails(localStorage.currentId);
    });

    //If no favorites display appropriate message
    if ($('#lvFavorites li').size() == 0) {
        $("#favoritesStatusMsg").show();
    }
    else {
        $("#favoritesStatusMsg").hide();
    }
}

function fileExists(sUrl) {
    $.ajax({ url: sUrl,
        beforeSend: function () { },
        complete: function () { },
        success: function (data, textStatus) { alert('success'); },
        error: function (jqXHR, textStatus, errorThrown) { alert('fail'); }
    });
} 